#!/usr/bin/php-cgi
<?php
	include("topinsert.php");
  include("functionscompact.php");
?>
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
    <title><?php echo $dTitle; ?></title>
    <link rel="icon" sizes="16x16 32x32" type="image/x-icon" href="/favicon.ico">
    <link href="<?php echo $GLOBALS['vendorsPath']?>vendors/bootstrap/css/bootstrap.min.css" rel="stylesheet">
    <link href="<?php echo $GLOBALS['vendorsPath']?>vendors/fontawesome/css/font-awesome.min.css" rel="stylesheet">
    <?php include $GLOBALS['assetsPath'].'css/style.php';?>
    <script src="<?php echo $GLOBALS['vendorsPath']?>vendors/js/modernzr.custom.js"></script>
    <?php include $GLOBALS['assetsPath'].'css/menu.php';?>    
    <?php include "../m/funcjs.php"; ?>
    <style>
      .bottom-url-logout{
        margin-left: 38.2% !important;
      }
      @media (max-width: 500px){
        .bottom-url-logout {
            margin-left: 0 !important;
        }
      }
    </style>  
  </head>
  <body>
  <div class="container landing-page-center">
      <!-- start header -->
      <div class="row header" style="position:relative">
        <!-- <div class="header-logo"></div> -->
        <div class="partner-logo">
            <img src="<?php echo $partner_logo64;?>">
        </div>
        <div class="header-logo">          
        </div>
      </div>
      <!-- end header -->
      <!-- content -->
      <div class="container-fluid">
		<div class="row-fluid">
            <div class="col-md-2"></div>
            <div class="col-md-8">
              <div id="menu_panel_container" class="menu-panel">
                <div class="loading-controls">
                  <p style="text-align:center;color:#fff"><i class="fa fa-spinner fa-spin"></i> Loading Settings.</p>
                </div>
              </div><!-- end div.menu-panel -->
            </div><!-- end col-md-12 -->
            <div class="col-md-2"></div>
      	</div>
      </div><!-- content -->

    </div><!-- end container -->
    <!-- footer -->
    <div class="footer-style-2" style="text-align:center"><img style="margin:20px 0 0 44px" class="footer-image" src="<?php echo $GLOBALS['linkPath']?>images/smsgloballogo_.png"></div>
    <!-- footer -->    
    <!-- MODALS STARTS HERE -->
    <?php include 'controlpanel.php';?>
    <!-- MODALS ENDS HERE -->
    
    <?php include '../m/inetrelated.php'; ?>

    <?php $mobileSiteShow = true?>
    <script src="<?php echo $GLOBALS['vendorsPath']?>vendors/jquery/jquery.js"></script>
	  <script src="<?php echo $GLOBALS['vendorsPath']?>vendors/jquery/jquery-ui.min.js"></script>
    <script src="<?php echo $GLOBALS['vendorsPath']?>vendors/bootstrap/js/bootstrap.min.js"></script>  
    <script src="<?php echo $GLOBALS['vendorsPath']?>vendors/js/jquery.bpopup.min.js"></script>
    <script type="text/javascript" src="<?php echo $GLOBALS['mobilePath']; ?>vendors/cropbox.js"></script>
    <script src="<?php echo $GLOBALS['vendorsPath']?>js/main.js"></script>
    <script type="text/javascript" src="<?php echo $GLOBALS['mobilePath']; ?>js/jquery.base64.js"></script>
    
    <?php if(isset($mobileSiteShow) &&  $mobileSiteShow === true):?>
        <?php echo detectUserAgent(' style="width:100%;padding:0 0 10px; 0" align="center"'); ?>
    <?php else:?>
        <div class="mobile-browser-tablet-detect__footer">
            <?php echo detectUserAgent(' style="width:100%;padding:0 0 10px; 0" align="center"'); ?>
        </div>
    <?php endif;?>

	<?php include "loading.php"; ?>
  <?php include "dfoot.php"; ?>

  <script type="text/javascript">
    $(document).ready(function(){
      $('.menu-panel__menu-link').hover(
        function(){
          var images = $(this).find('img');
          var onhover = images.attr('data-src');
          images.attr('src',onhover);
          // alert(original);
          // alert(onhover);
        },function(){
          var images = $(this).find('img');
          var original = images.attr('data-osrc');
          images.attr('src',original);
        });
    });

    var _sbconfig = JSON.parse( localStorage.getItem('VesselConfig') );
    var _srvcs =  _sbconfig !== null && typeof _sbconfig.data[0] !== "undefined" ? _sbconfig.data[0].server_services : '000000' ;
    var _menuTemplate = '';
        _menuTemplate += '<ul id="menu-panel__menu" class="menu-panel__menu {{grid}}">';
        _menuTemplate += '<li class="{{second-layer}}">';
        _menuTemplate += '  <a href="emailandsms.inbox.php" class="menu-panel__menu-link link-emailsms">';
        _menuTemplate += '    <img src="<?php echo $GLOBALS['linkPath']?>images/emailsms-002.png" data-osrc="<?php echo $GLOBALS['linkPath']?>images/emailsms-002.png" data-src="<?php echo $GLOBALS['linkPath']?>images/emailsms-001.png">';
        _menuTemplate += '    <span class="menu-panel__label">E-mail & SMS</span>';
        _menuTemplate += '  </a>';
        _menuTemplate += '</li>';
        _menuTemplate += '<li>';
        _menuTemplate += '  <a href="fleet.php" class="menu-panel__menu-link link-announce">';
        _menuTemplate += '    <img src="<?php echo $GLOBALS['linkPath']?>images/announcements-002.png" data-osrc="<?php echo $GLOBALS['linkPath']?>images/announcements-002.png" data-src="<?php echo $GLOBALS['linkPath']?>images/announcements-001.png">';
        _menuTemplate += '    <span class="menu-panel__label">Announcements</span>';
        _menuTemplate += '  </a>';
        _menuTemplate += '</li>';

        if(_srvcs[1] == '1'){
                _menuTemplate += '<li>';
                _menuTemplate += '  <a href="news.php" class="menu-panel__menu-link link-worldnews">';
                _menuTemplate += '    <img src="<?php echo $GLOBALS['linkPath']?>images/news.png" data-osrc="<?php echo $GLOBALS['linkPath']?>images/news.png" data-src="<?php echo $GLOBALS['linkPath']?>images/news-001.png">';
                _menuTemplate += '    <span class="menu-panel__label">World News</span>';
                _menuTemplate += '  </a>';
                _menuTemplate += '</li>';
        }

        if(_srvcs[3] == '1'){
          _menuTemplate += '<li id="menu_internet" class="{{second-layer}}">';
          _menuTemplate += '  <a href="javascript:;" onClick="onoffinet(\'1\', \'1\');" class="menu-panel__menu-link link-internet" id="activatingModal-open"><img src="<?php echo $GLOBALS['linkPath']?>images/internet.png" data-osrc="<?php echo $GLOBALS['linkPath']?>images/internet.png" data-src="<?php echo $GLOBALS['linkPath']?>images/internet-001.png">';
          _menuTemplate += '    <span class="menu-panel__label">Internet</span>';
          _menuTemplate += '  </a>';
          _menuTemplate += '</li>';
        }
        
        <?php if( @$GLOBALS['webbrowsing'] === true ): ?>
          if(_srvcs[3] == '1'){
            _menuTemplate += '<li id="menu_seamenow">';
            _menuTemplate += '  <a href="seamenow.php" class="menu-panel__menu-link link-seenow">';
            _menuTemplate += '    <img src="<?php echo $GLOBALS['linkPath']?>images/semenow.png" data-osrc="<?php echo $GLOBALS['linkPath']?>images/semenow.png" data-src="<?php echo $GLOBALS['linkPath']?>images/semenow-001.png">';
            _menuTemplate += '    <span class="menu-panel__label">Se@MeNow</span>';
            _menuTemplate += '  </a>';
            _menuTemplate += '</li>';
          }
          
          if(_srvcs[2] == '1'){
              _menuTemplate += '<li id="menu_lowdatachat">';
              _menuTemplate += '  <a href="chat.php" class="menu-panel__menu-link link-chat">';
              _menuTemplate += '    <img src="<?php echo $GLOBALS['linkPath']?>images/chat.png" data-osrc="<?php echo $GLOBALS['linkPath']?>images/chat.png" data-src="<?php echo $GLOBALS['linkPath']?>images/chat-001.png">';
              _menuTemplate += '    <span class="menu-panel__label">Low Data Chat</span>';
              _menuTemplate += '  </a>                    ';
              _menuTemplate += '</li>';
          }

          _menuTemplate += '<li class="{{third-layer}}">';
          _menuTemplate += '  <a href="javascript:;" id="usercontrolpanel" class="menu-panel__menu-link link-controlpanel">';
          _menuTemplate += '    <img src="<?php echo $GLOBALS['linkPath']?>images/controlpanel.png" data-osrc="<?php echo $GLOBALS['linkPath']?>images/controlpanel.png" data-src="<?php echo $GLOBALS['linkPath']?>images/controlpanel-001.png"> ';
          _menuTemplate += '    <span class="menu-panel__label">User Control Panel</span>';
          _menuTemplate += '  </a>';
          _menuTemplate += '</li>';
          _menuTemplate += '<li>';
          _menuTemplate += '  <a href="../m/serv.php?act=0&dir=d" onClick="showLoadingMessageDisp(\'Logging off... Please wait.\');$(window).unbind(\'beforeunload\');" class="menu-panel__menu-link link-logout">';
          _menuTemplate += '    <img src="<?php echo $GLOBALS['linkPath']?>images/logout.png" data-osrc="<?php echo $GLOBALS['linkPath']?>images/logout.png" data-src="<?php echo $GLOBALS['linkPath']?>images/logout-001.png">';
          _menuTemplate += '    <span class="menu-panel__label">Log Off</span>';
          _menuTemplate += '  </a>';
          _menuTemplate += '</li>';          
        <?php else: ?>

            if(_srvcs[2] == '1'){
                _menuTemplate += '<li id="menu_lowdatachat">';
                _menuTemplate += '  <a href="chat.php" class="menu-panel__menu-link link-chat">';
                _menuTemplate += '    <img src="<?php echo $GLOBALS['linkPath']?>images/chat.png" data-osrc="<?php echo $GLOBALS['linkPath']?>images/chat.png" data-src="<?php echo $GLOBALS['linkPath']?>images/chat-001.png">';
                _menuTemplate += '    <span class="menu-panel__label">Low Data Chat</span>';
                _menuTemplate += '  </a>                    ';
                _menuTemplate += '</li>';

                _menuTemplate += '<li class="">';
                _menuTemplate += '  <a href="javascript:;" id="usercontrolpanel" class="menu-panel__menu-link link-controlpanel">';
                _menuTemplate += '    <img src="<?php echo $GLOBALS['linkPath']?>images/controlpanel.png" data-osrc="<?php echo $GLOBALS['linkPath']?>images/controlpanel.png" data-src="<?php echo $GLOBALS['linkPath']?>images/controlpanel-001.png"> ';
                _menuTemplate += '    <span class="menu-panel__label">User Control Panel</span>';
                _menuTemplate += '  </a>';
                _menuTemplate += '</li>';

                if(_srvcs[3] == '1' && _srvcs[1] == '1'){
                    _menuTemplate += '<li class="bottom-url-logout">';
                    _menuTemplate += '  <a href="../m/serv.php?act=0&dir=d" onClick="showLoadingMessageDisp(\'Logging off... Please wait.\');$(window).unbind(\'beforeunload\');" class="menu-panel__menu-link link-logout">';
                    _menuTemplate += '    <img src="<?php echo $GLOBALS['linkPath']?>images/logout.png" data-osrc="<?php echo $GLOBALS['linkPath']?>images/logout.png" data-src="<?php echo $GLOBALS['linkPath']?>images/logout-001.png">';
                    _menuTemplate += '    <span class="menu-panel__label">Log Off</span>';
                    _menuTemplate += '  </a>';
                    _menuTemplate += '</li>'; 
                }else{
                  _menuTemplate += '<li>';
                    _menuTemplate += '  <a href="../m/serv.php?act=0&dir=d" onClick="showLoadingMessageDisp(\'Logging off... Please wait.\');$(window).unbind(\'beforeunload\');" class="menu-panel__menu-link link-logout">';
                    _menuTemplate += '    <img src="<?php echo $GLOBALS['linkPath']?>images/logout.png" data-osrc="<?php echo $GLOBALS['linkPath']?>images/logout.png" data-src="<?php echo $GLOBALS['linkPath']?>images/logout-001.png">';
                    _menuTemplate += '    <span class="menu-panel__label">Log Off</span>';
                    _menuTemplate += '  </a>';
                    _menuTemplate += '</li>'; 
                }
                

            }else{

              _menuTemplate += '<li class="">';
              _menuTemplate += '  <a href="javascript:;" id="usercontrolpanel" class="menu-panel__menu-link link-controlpanel">';
              _menuTemplate += '    <img src="<?php echo $GLOBALS['linkPath']?>images/controlpanel.png" data-osrc="<?php echo $GLOBALS['linkPath']?>images/controlpanel.png" data-src="<?php echo $GLOBALS['linkPath']?>images/controlpanel-001.png"> ';
              _menuTemplate += '    <span class="menu-panel__label">User Control Panel</span>';
              _menuTemplate += '  </a>';
              _menuTemplate += '</li>';

              _menuTemplate += '<li class="">';  
              _menuTemplate += '  <a href="../m/serv.php?act=0&dir=d" onClick="showLoadingMessageDisp(\'Logging off... Please wait.\');$(window).unbind(\'beforeunload\');" class="menu-panel__menu-link link-logout">';
              _menuTemplate += '    <img src="<?php echo $GLOBALS['linkPath']?>images/logout.png" data-osrc="<?php echo $GLOBALS['linkPath']?>images/logout.png" data-src="<?php echo $GLOBALS['linkPath']?>images/logout-001.png">';
              _menuTemplate += '    <span class="menu-panel__label">Log Off</span>';
              _menuTemplate += '  </a>';
              _menuTemplate += '</li>'; 
            }
        <?php endif; ?>

          _menuTemplate += '</ul>';

      if(_srvcs[1] == '0' && _srvcs[2] == 1 && _srvcs[3] == 1){

      }else{
        if(_srvcs[3] == '0' || _srvcs[2] == '0'){
          _menuTemplate = _menuTemplate.replace(/{{third-layer}}/gi,'');
          _menuTemplate = _menuTemplate.replace(/{{second-layer}}/gi,'');        
          _menuTemplate = _menuTemplate.replace(/{{grid}}/gi,'menu-panel--three');        
        }else{
          _menuTemplate = _menuTemplate.replace(/{{third-layer}}/gi,'third-layer');
          _menuTemplate = _menuTemplate.replace(/{{second-layer}}/gi,'second-layer');        
          _menuTemplate = _menuTemplate.replace(/{{grid}}/gi,'menu-panel--four');        
        }
      }

      document.getElementById('menu_panel_container').innerHTML  = _menuTemplate;  
  
  </script>
  </body>
</html>
<?php include "../m/foot.php"; ?>