#!/usr/bin/php-cgi
<?php
	include("topinsert.php");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<title><?php echo $dTitle; ?></title>
	<link rel="stylesheet" type="text/css" href="<?php echo $GLOBALS['vendorsPath']; ?>vendors/bootstrap/css/bootstrap.min.css">
	<link rel="stylesheet" type="text/css" href="<?php echo $GLOBALS['vendorsPath']; ?>vendors/fontawesome/css/font-awesome.min.css">
    <?php include $GLOBALS['assetsPath']."css/style.php"; ?>
    <!-- <meta name="viewport" content="width=device-width, initial-scale=1"> -->
	<meta name='viewport' content="width=device-width, maximum-scale=1.0, minimum-scale=1.0, initial-scale=1.0" />
    
<?php include "funcjs.php"; ?>
</head>
<body>
		<div id="wrapper" style="background-color:#E8E9EA">
			<!-- wrapper -->
			<!-- Sidebar -->
			<?php include('sidebar.php'); ?>
        <!-- /#sidebar-wrapper -->

        <div id="page-content-wrapper">
				<!-- Header -->
				<nav>
					<?php 
						//@function at sidebar.php
						//@param1 name of page
						//@param2 search icon class name
						echo page_title('Vessel Media');
					?>
				</nav>
				<!-- Header -->
				
				<div class="clearfix"></div>
				<!-- COntent/container -->
				<div class="row-fluid">
					<div class="search-container">
						<input>
					</div>
					<div class="js-auto-height background--gray">
						<div class="internet-container">
							<div class="internet-connection-info">
								<div style="height:8"></div>
								<div class="news-listings" style="padding-bottom: 15px;">
									<ul class="message-preview">
                                        <li id="loading-message" style="text-align:center"><i class="fa fa-spinner fa-spin"></i> Retrieving Vessel Media</li>
                                    </ul>
								</div>
							</div>
						</div>
					</div>
					<div class="clearfix"></div>
				</div>
				<!-- COntent/container -->

			</div><!--#page content wrapper -->
		</div><!--#Wrapper -->

<script type="text/javascript" src="<?php echo $GLOBALS['vendorsPath']; ?>vendors/jquery/jquery.js"></script>
<script type="text/javascript" src="<?php echo $GLOBALS['vendorsPath']; ?>vendors/jquery/jquery.mobile.custom.min.js"></script>
<script type="text/javascript" src="<?php echo $GLOBALS['vendorsPath']; ?>vendors/bootstrap/js/bootstrap.min.js"></script>
<script type="text/javascript" src="<?php echo $GLOBALS['vendorsPath']; ?>js/jquery.base64.js"></script>
<script type="text/javascript" src="<?php echo $GLOBALS['vendorsPath']; ?>js/main.js"></script>
<script type="text/javascript" src="<?php echo $GLOBALS['vendorsPath']; ?>js/nav.js"></script>

<?php include "loading.php"; ?>
<iframe id="downloadframe" style='display:none;'></iframe>
</body>
</html>
<script>
//var dirlist = 'http://<?php //echo (($_SERVER['SERVER_ADDR'] == "::1")?"localhost":$_SERVER['SERVER_ADDR']); ?>/cgi-bin/dirlistgui.php'; //Add this to a variable
var dirlist = '<?php echo (($isProd)?"http://" . $_SERVER['SERVER_ADDR']."/cgi-bin/dirlistgui.php":"http://localhost/smscrewmail/mailparser/production/serverfiles/management/dirlistgui.php"); ?>'; //Add this to a variable
//var servdhost = 'http://192.168.32.1/cgi-bin/serv.php'; //Add this to a variable
var currpath = "";
var selectdf = "";

function myTrim(x) {
	return x.replace(/^\s+|\s+$/gm,'');
}

function fetchDirJS(path, act, fname) {
	currpath = path;
	
	var requestdirlist;
	var noerror = true;
	var dhost = dirlist;
	var mediaCnt = 0;
	
	requestdirlist = $.ajax({
		url: dhost,
		type: "post",
		data: { path: path, act: act, fname: fname },
		//dataType:"json",
		timeout: 30000
	});
	
	requestdirlist.done(function (response, textStatus, jqXHR){
		if (noerror) {
			try {
			
				response = response.replace("#!/usr/bin/php-cgi", "");
				response = myTrim(response);
				var ret = response.split("[FILESEP]");
				try {
					$('div.news-listings').empty();
					for (var i=0;i<ret.length;i++) {
						ret[i] = ret[i].replace("[FILESEP]", "");
						if (ret[i] == "No files found.") {
						} else {
							if (ret[i].length > 0) {
								//Process filename here, call showopts with ret[i] as parameter for download option
								disp = '<a href="javascript:;" onClick="showopts(\'' + ret[i] + '\')">';
								disp += '<h1 class="news-listings__title" style="padding-bottom:15px">' + ret[i] + '</h1>';
								disp += '</a>';
								
								$('div.news-listings').append(
									disp
								);
								
								mediaCnt++;
							}
						}
					}
				} catch (e) {}
				
				if (mediaCnt == 0) {
					$('div.news-listings').empty();
					disp = '<ul class="message-preview">';
					disp += '<li id="loading-message" style="text-align:center">No media files available.</li>';
					disp += '</ul>';
					$('div.news-listings').append(
						disp
					);
				}
			
			} catch (e) {}
		}
	});

	requestdirlist.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
		/*if (textStatus=="timeout") {
			alert('The request timed out. Please try again.');
		} else {
			alert('An error has occurred. Please try again.');
		}*/
		
		$('div.news-listings').empty();
		disp = '<ul class="message-preview">';
		disp += '<li id="loading-message" style="text-align:center">No media files available.</li>';
		disp += '</ul>';
		$('div.news-listings').append(
			disp
		);
	});

	requestdirlist.always(function () {
		requestdirlist = null;
	});
}

//Called this function (filename as parameter) when the user clicks on a media item.
function showopts(fn) {
	selectdf = fn;
	
	/*if (confirm("Are you sure you want to download " + selectdf + "?")) {
		downloadopts();
	}*/
	
	sweetAlert({
			title: "Vessel Media",
			text: "Are you sure you want to download " + selectdf + "?",
			showCancelButton: true,
			confirmButtonText: "Yes",
			cancelButtonText: "No",
			closeOnConfirm: true,
			closeOnCancel: true 
		},
		function(isConfirm){
			if (isConfirm) {
				downloadopts();
			}
		}
	);
}

function downloadopts() {
	var dhost = 'http://<?php echo (($_SERVER['SERVER_ADDR'] == "::1")?"localhost":$_SERVER['SERVER_ADDR']); ?>/cgi-bin/serv.php';
	document.getElementById('downloadframe').src = dhost + "?act=2&path=" + encodeURIComponent(currpath.replace(/&amp;/g, "&")) + "&fname=" + encodeURIComponent(selectdf.replace(/&amp;/g, "&"));
}

fetchDirJS(currpath, "1", ""); //Call this to fetch media file list

$(document).ready(function(){
	fetchDirJS(currpath, "1", "");
});
</script>
<?php include "foot.php"; ?>