#!/usr/bin/php-cgi
<?php
	error_reporting(0);
	set_time_limit(1800);
	
	if (isset($_SERVER['SERVER_ADDR'])) {} else {
		$host= gethostname();
		$ip = gethostbyname($host);
		$_SERVER['SERVER_ADDR'] = $ip;
	}
	
	function savetoTMP($fname, $msg) {
		$iniFile = $fname;
		if (is_file($iniFile)) {
			//Do nothing... File already exists
		} else {
			//Try to create
			$fh = fopen($iniFile, 'w+');
			fclose($fh);
		}
		file_put_contents($iniFile,$msg,FILE_APPEND);
	}
	
	$GLOBALS['SERVERURLFOUND'] = "";
	
	function checkServerConnectionCLI($jsonEncodedContent, $url, $iplist) {
		$ret = "";
		
		if (strlen($GLOBALS['SERVERURLFOUND']) > 5) {
			$ret = $GLOBALS['SERVERURLFOUND'];
		} else {
		
			$arr_iplist = explode(",", $iplist);
			
			$retries = 3; $connSuccess = false;
			for ($ii=0; $ii<$retries; $ii++) {
			
				for ($i=0; $i<count($arr_iplist); $i++) {
					$durl = str_replace("[CHANGEIP]", $arr_iplist[$i], $url) . "api/lib/sschk.php";
					
					$context = stream_context_create(array(
						'http' => array(
							'header'  => "Content-Type: application/x-www-form-urlencoded",
							'method'  => 'POST',
							'content' => http_build_query($jsonEncodedContent)
						)
					));
					
					$response = file_get_contents($durl, false, $context);
					if ($response === FALSE){
					} else {
						if (($response == "1") || ($response == 1)) {
							$ret = $arr_iplist[$i];
							$connSuccess = true;
							break;
						}
					}
				}
			
			}
		
		}
		
		return $ret;
	}
	
	$isCLI = true; $islogged = true; $ishome = true;
	include("globals.php");
	
	function debugEcho($msg) {
		//savetoTMP("/tmp/RedPortSync.txt", $msg . "\r\n");
		
		if ($GLOBALS['isprod']) {
			//savetoTMP("/tmp/RedPortSync.txt", $msg . "\r\n");
			
			savetoTMP("/tmp/RedPortSync.txt", $msg . "\n");
			echo $msg . "\n";
		} else {
			echo $msg . "\r\n";
		}
	}
	
	function debugPrintR($msg) {
		//savetoTMP("/tmp/RedPortSync.txt", print_r( $msg, true ) . "\r\n" );
		
		if ($GLOBALS['isprod']) {
			//savetoTMP("/tmp/RedPortSync.txt", print_r( $msg, true ) . "\r\n" );
			
			savetoTMP("/tmp/RedPortSync.txt", print_r( $msg, true ) . "\n" );
			print_r( $msg );
			echo "\n";
		} else {
			print_r( $msg );
			echo "\r\n";
		}
	}
	
	debugEcho( "" );
	debugEcho( "" );
	debugEcho( "=================================== " . date("M d Y h:s:i A") );
	debugEcho( "Hello RedPort!" );
	
	$GLOBALS['SERVERURLFOUND'] = checkServerConnectionCLI($postData, $GLOBALS['SERVERURL'], $GLOBALS['SSIP']);
	$GLOBALS['SERVERURL'] = "http://" . $GLOBALS['SERVERURLFOUND'] . ":10990/smsglobal/";
	
	$GLOBALS['macid'] = getMacAdd();
	debugEcho( $GLOBALS['macid'] );	
	
	//GET UPDATE LIST
	$GLOBALS['ss_update_email'] = "0";
	$GLOBALS['ss_update_gps'] = "0";
	$GLOBALS['ss_update_remote'] = "0";
	$GLOBALS['ss_update_voip'] = "0";
	
	function getUpdatedSettingsList() {
		$ret = true;
		$postData = array('macid' => $GLOBALS['macid'], 'vesselid' => "");
		debugPrintR($postData);
		$durl = $GLOBALS['SERVERURL'] . 'redportapi/rest/requestsourceupdate';
		debugEcho( "UPDATES: " . $durl );	
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'POST',
				'content' => http_build_query($postData)
			)
		));
		$response = file_get_contents($durl, false, $context);
		
		if ($response === FALSE){
			$ret = false;
		} else {
			$res = json_decode($response, true);
			debugPrintR($res);
			
			foreach($res as $key=>$val){ 
				foreach($val as $key1=>$val1){ 
					if ($key1 == "email") {
						$GLOBALS['ss_update_email'] = $val1;
					} else if ($key1 == "remote") {
						$GLOBALS['ss_update_remote'] = $val1;
					} else if ($key1 == "voip") {
						$GLOBALS['ss_update_voip'] = $val1;
					} else if ($key1 == "gps") {
						$GLOBALS['ss_update_gps'] = $val1;
					}
				}
			}
		}
		
		return $ret;
	}
	
	getUpdatedSettingsList();
	
	debugEcho( "ss_update_email: " . $GLOBALS['ss_update_email'] );
	debugEcho( "ss_update_gps: " . $GLOBALS['ss_update_gps'] );
	debugEcho( "ss_update_remote: " . $GLOBALS['ss_update_remote'] );
	debugEcho( "ss_update_voip: " . $GLOBALS['ss_update_voip'] );
	//GET UPDATE LIST
	
	//REMOTE SETTINGS
	$GLOBALS['ss_remid'] = "";
	$GLOBALS['ss_remoteacc_opn'] = "0";
	$GLOBALS['ss_remoteacc_port'] = ""; //8042
	$GLOBALS['ss_remoteacc_http'] = "";
	$GLOBALS['ss_remoteacc_ssh'] = "";
	
	function getRemoteSettings() {
		$ret = true;
		$postData = array('macid' => $GLOBALS['macid'], 'vesselid' => "", 'source' => "0");
		debugPrintR($postData);
		$durl = $GLOBALS['SERVERURL'] . 'redportapi/rest/requestremoteaccesssettings';
		debugEcho( "REMOTE: " . $durl );
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'POST',
				'content' => http_build_query($postData)
			)
		));
		$response = file_get_contents($durl, false, $context);
		
		if ($response === FALSE){
			$ret = false;
		} else {
			$res = json_decode($response, true);
			debugPrintR($res);
			
			foreach($res as $key=>$val){ 
				foreach($val as $key1=>$val1){ 
					if ($key1 == "remid") {
						$GLOBALS['ss_remid'] = $val1;
					} else if ($key1 == "switch") { //remote_enable
						$GLOBALS['ss_remoteacc_opn'] = $val1;
					} else if ($key1 == "port") { //remote_port
						$GLOBALS['ss_remoteacc_port'] = $val1;
					} else if ($key1 == "http") { //remote_port
						$GLOBALS['ss_remoteacc_http'] = $val1;
					} else if ($key1 == "ssh") { //remote_port
						$GLOBALS['ss_remoteacc_ssh'] = $val1;
					}
				}
			}
		}
		
		debugEcho( "ss_remid: " . $GLOBALS['ss_remid'] );
		debugEcho( "ss_remoteacc_opn: " . $GLOBALS['ss_remoteacc_opn'] );
		debugEcho( "ss_remoteacc_port: " . $GLOBALS['ss_remoteacc_port'] );
		debugEcho( "ss_remoteacc_http: " . $GLOBALS['ss_remoteacc_http'] );
		debugEcho( "ss_remoteacc_ssh: " . $GLOBALS['ss_remoteacc_ssh'] );
		
		return $ret;
	}
	
	function saveRemoteConfigLocal() {
		$durl = $GLOBALS['RPREMOTE'] . '?stop';
		if ($GLOBALS['ss_remoteacc_opn'] == "1") {
			$durl = $GLOBALS['RPREMOTE'] . '?start';
		}
		debugEcho( "REMOTE LOCAL: " . $durl );
		
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'GET',
				'timeout' => 60,
				'content' => http_build_query($postData)
			)
		));
		$response = file_get_contents($durl, false, $context);
		
		if ($response === FALSE){
			$ret = false;
		} else {
			if ($GLOBALS['ss_remoteacc_opn'] == "1") {
				getRemoteSettingsLocal();
			} else {
				$GLOBALS['ss_remoteacc_http'] = "";
				$GLOBALS['ss_remoteacc_ssh'] = "";
			}
		}
	}
	
	function getRemoteSettingsLocal() {
		$durl = $GLOBALS['RPREMOTE'] . '?getport';
		debugEcho( "REMOTE LOCAL GET PORT: " . $durl );
		
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'GET',
				'content' => http_build_query($postData)
			)
		));
		$response = file_get_contents($durl, false, $context);
		
		if ($response === FALSE){
			$ret = false;
		} else {
			debugPrintR($response);
			
			$response = str_replace("</pre>", "", $response);
			$response = str_replace("</pre>", "", $response);
			$response = str_replace("<pre>", "", $response);
			$response = str_replace("<pre>", "", $response);
			$responseArr = explode("\n", $response);
			debugPrintR($responseArr);
			
			for ($i=0; $i<count($responseArr); $i++) {
				if (strrpos($responseArr[$i], "http") === false) {} else {
					$GLOBALS['ss_remoteacc_http'] = trim( $responseArr[$i] );
				}
				
				if (strrpos($responseArr[$i], "ssh") === false) {} else {
					$GLOBALS['ss_remoteacc_ssh'] = trim( $responseArr[$i] );
				}
			}
			
			saveRemoteConfigCS();
		}
	}
	
	function saveRemoteConfigCS() {
		$ret = true;
		$postData = array(
			'remmacid' => $GLOBALS['macid'],
			'remvessid' => "",
			'remswitch' => ($GLOBALS['ss_remoteacc_opn']?"1":"0"),
			'remport' => ((strlen($GLOBALS['ss_remoteacc_port']) == 0)?"8042":$GLOBALS['ss_remoteacc_port']),
			'remhttp' => $GLOBALS['ss_remoteacc_http'],
			'remssh' => $GLOBALS['ss_remoteacc_ssh'],
			'partner' => '',
			'fleetid' => '',
			'id' => '0',
			'proc' => '4',
			'source' => '0'
		);
		debugPrintR($postData);
		$durl = $GLOBALS['SERVERURL'] . 'redportapi/lib/remotesettings.php';
		debugEcho( "UPDATES: " . $durl );	
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'POST',
				'content' => http_build_query($postData)
			)
		));
		$response = file_get_contents($durl, false, $context);
		
		if ($response === FALSE){
			$ret = false;
		} else {
			debugPrintR($response);
		}
		
		return $ret;
	}
	//REMOTE SETTINGS
	
	//GPS SETTINGS
	$GLOBALS['ss_gpsid'] = "";
	$GLOBALS['ss_gps_opn'] = "0";
	$GLOBALS['ss_gps_interval'] = ""; //60
	$GLOBALS['ss_gps_inmarsatfbb'] = "0";
	$GLOBALS['ss_gps_vsatbb'] = "0";
	$GLOBALS['ss_gps_nmeaopn'] = "0";
	$GLOBALS['ss_gps_nmeausb'] = "0";
	$GLOBALS['ss_gps_udplistenport'] = ""; //10101
	$GLOBALS['ss_gps_udpport'] = ""; //11101
	$GLOBALS['ss_gps_tcpport'] = ""; //11102
	
	function getGPSSettings() {
		$ret = true;
		$postData = array('macid' => $GLOBALS['macid'], 'vesselid' => "", 'source' => "0");
		debugPrintR($postData);
		$durl = $GLOBALS['SERVERURL'] . 'redportapi/rest/requestgpssettings';
		debugEcho( "GPS: " . $durl );
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'POST',
				'content' => http_build_query($postData)
			)
		));
		$response = file_get_contents($durl, false, $context);
		
		if ($response === FALSE){
			$ret = false;
		} else {
			$res = json_decode($response, true);
			debugPrintR($res);
			
			foreach($res as $key=>$val){ 
				foreach($val as $key1=>$val1){ 
					switch(strtolower($key1)) {
						case "gpsid":
							$GLOBALS['ss_gpsid'] = $val1;
							break;
						case "switch": //gps_enable
							$GLOBALS['ss_gps_opn'] = $val1;
							break;
						case "interval": //gps_interval
							$GLOBALS['ss_gps_interval'] = $val1;
							break;
						case "sat1": //sat1
							$GLOBALS['ss_gps_inmarsatfbb'] = $val1;
							break;
						case "sat2": //sat2
							$GLOBALS['ss_gps_vsatbb'] = $val1;
							break;
						case "monitoring": //monitoring_enable
							$GLOBALS['ss_gps_nmeaopn'] = $val1;
							break;
						case "usbfeed": //usb_feed
							$GLOBALS['ss_gps_nmeausb'] = $val1;
							break;
						case "udplisten": //udp_listenport
							$GLOBALS['ss_gps_udplistenport'] = $val1;
							break;
						case "udpport": //udp_port
							$GLOBALS['ss_gps_udpport'] = $val1;
							break;
						case "tcpport": //tcp_port
							$GLOBALS['ss_gps_tcpport'] = $val1;
							break;
					}
				}
			}
		}
		
		debugEcho( "ss_gpsid: " . $GLOBALS['ss_gpsid'] );
		debugEcho( "ss_gps_opn: " . $GLOBALS['ss_gps_opn'] );
		debugEcho( "ss_gps_interval: " . $GLOBALS['ss_gps_interval'] );
		debugEcho( "ss_gps_inmarsatfbb: " . $GLOBALS['ss_gps_inmarsatfbb'] );
		debugEcho( "ss_gps_vsatbb: " . $GLOBALS['ss_gps_vsatbb'] );
		debugEcho( "ss_gps_nmeaopn: " . $GLOBALS['ss_gps_nmeaopn'] );
		debugEcho( "ss_gps_nmeausb: " . $GLOBALS['ss_gps_nmeausb'] );
		debugEcho( "ss_gps_udplistenport: " . $GLOBALS['ss_gps_udplistenport'] );
		debugEcho( "ss_gps_udpport: " . $GLOBALS['ss_gps_udpport'] );
		debugEcho( "ss_gps_tcpport: " . $GLOBALS['ss_gps_tcpport'] );
		
		return $ret;
	}
	
	function saveGPSConfigLocal() {
		$arrGPS = array(); $arrGPSSub = array(array());
		
		$arrGPSSub[0] = "NMEA";
		$arrGPSSub[1] = (($GLOBALS['ss_gps_nmeaopn']=="0")?"off":"on"); //$GLOBALS['ss_gps_nmeaopn']; 
		$arrGPSSub[2] = "enabled";
		$arrGPS[0] = $arrGPSSub;
		$arrGPSSub = array();
		
		$arrGPSSub[0] = "NMEA";
		$arrGPSSub[1] = (($GLOBALS['ss_gps_nmeausb']=="0")?"off":"on"); //$GLOBALS['ss_gps_nmeausb'];
		$arrGPSSub[2] = "usb";
		$arrGPS[1] = $arrGPSSub;
		$arrGPSSub = array();
		
		$arrGPSSub[0] = "NMEA";
		$arrGPSSub[1] = $GLOBALS['ss_gps_udplistenport'];
		$arrGPSSub[2] = "listen";
		$arrGPS[2] = $arrGPSSub;
		$arrGPSSub = array();
		
		$arrGPSSub[0] = "NMEA";
		$arrGPSSub[1] = $GLOBALS['ss_gps_udpport'];
		$arrGPSSub[2] = "udp";
		$arrGPS[3] = $arrGPSSub;
		$arrGPSSub = array();
		
		$arrGPSSub[0] = "NMEA";
		$arrGPSSub[1] = $GLOBALS['ss_gps_tcpport'];
		$arrGPSSub[2] = "tcp";
		$arrGPS[4] = $arrGPSSub;
		$arrGPSSub = array();
		
		$arrGPSSub[0] = "NMEA";
		$arrGPSSub[1] = "start";
		$arrGPSSub[2] = "start";
		$arrGPS[5] = $arrGPSSub;
		$arrGPSSub = array();
		
		$arrGPSSub[0] = "GPS";
		$arrGPSSub[1] = (($GLOBALS['ss_gps_opn']=="0")?"off":"on"); //$GLOBALS['ss_gps_opn'];
		$arrGPSSub[2] = "enabled";
		$arrGPS[6] = $arrGPSSub;
		$arrGPSSub = array();
		
		$arrGPSSub[0] = "GPS";
		$arrGPSSub[1] = $GLOBALS['ss_gps_interval'];
		$arrGPSSub[2] = "interval";
		$arrGPS[7] = $arrGPSSub;
		$arrGPSSub = array();
		
		$arrGPSSub[0] = "GPS";
		$arrGPSSub[1] = (($GLOBALS['ss_gps_inmarsatfbb']=="0")?"off":"on"); //$GLOBALS['ss_gps_inmarsatfbb'];
		$arrGPSSub[2] = "GSATfbb";
		$arrGPS[8] = $arrGPSSub;
		$arrGPSSub = array();
		
		$arrGPSSub[0] = "GPS";
		$arrGPSSub[1] = (($GLOBALS['ss_gps_vsatbb']=="0")?"off":"on"); //$GLOBALS['ss_gps_vsatbb'];
		$arrGPSSub[2] = "GSATvsat";
		$arrGPS[9] = $arrGPSSub;
		$arrGPSSub = array();
		
		
		$arrGPSSub[0] = "GPS";
		$arrGPSSub[1] = "start";
		$arrGPSSub[2] = "start";
		$arrGPS[10] = $arrGPSSub;
		$arrGPSSub = array();
		
		saveGPSConfigSubmit($arrGPS);
	}
	
	function saveGPSConfigSubmit($arrGPS) {
		debugPrintR($arrGPS);
		
		for ($i=0; $i<count($arrGPS); $i++) {
			$param = $arrGPS[$i][2];
			$paramVal = $arrGPS[$i][1];
			$durl = $GLOBALS['RPNMEA'] . '?' . $param . '=' . urlencode($paramVal);
			if ($arrGPS[$i][0] == "GPS") {
				$durl = $GLOBALS['RPGPS'] . '?' . $param . '=' . urlencode($paramVal);
			}
			debugEcho($durl);
			
			$context = stream_context_create(array(
				'http' => array(
					'header'  => "Content-Type: application/x-www-form-urlencoded",
					'method'  => 'POST',
					'content' => http_build_query($jsonEncodedContent)
				)
			));
			
			$response = file_get_contents($durl, false, $context);
			if ($response === FALSE){
			} else {
				debugEcho( $response );
			}
		}
	}
	//GPS SETTINGS
	
	//VOIP SETTINGS
	$GLOBALS['ss_voipid'] = "";
	$GLOBALS['ss_voip_opn'] = "0";
	$GLOBALS['ss_voip_port'] = ""; //5060
	$GLOBALS['ss_voip_interface'] = "";
	$GLOBALS['ss_voip_paymode'] = "";
	$GLOBALS['ss_voip_numexts'] = 0;
	$GLOBALS['ss_voip_actkey'] = "";
	$GLOBALS['ss_voip_deactvobal'] = "0";
	$GLOBALS['ss_voip_uid'] = "";
	$GLOBALS['ss_voip_did'] = "";
	$GLOBALS['ss_voip_ext'] = array(array());
	
	function getVOIPSettings() {
		$GLOBALS['ss_voip_ext'] = array(array());
		
		$ret = true;
		$postData = array('macid' => $GLOBALS['macid'], 'vesselid' => "", 'source' => "0");
		debugPrintR($postData);
		$durl = $GLOBALS['SERVERURL'] . 'redportapi/rest/requestVOIPsettings';
		debugEcho( "VOIP: " . $durl );
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'POST',
				'content' => http_build_query($postData)
			)
		));
		$response = file_get_contents($durl, false, $context);
		
		if ($response === FALSE){
			$ret = false;
		} else {
			$res = json_decode($response, true);
			debugPrintR($res);
			
			$cnt = 0;
			foreach($res as $key=>$val){ 
				foreach($val as $key1=>$val1){ 
					if ($key1 == "voipsub") {
						foreach($val1 as $key2=>$val2){
							foreach($val2 as $key3=>$val3){
								switch(strtolower($key3)) {
									case "ring":
										$GLOBALS['ss_voip_ext'][$cnt][0] = $val3;
										break;
									case "sms":
										$GLOBALS['ss_voip_ext'][$cnt][1] = $val3;
										break;
									case "payment":
										$GLOBALS['ss_voip_ext'][$cnt][2] = $val3;
										break;
									case "extension":
										$GLOBALS['ss_voip_ext'][$cnt][3] = $val3;
										break;
									case "password":
										$GLOBALS['ss_voip_ext'][$cnt][4] = $val3;
										break;
									case "callid":
										$GLOBALS['ss_voip_ext'][$cnt][5] = $val3;
										break;
									case "desc":
										$GLOBALS['ss_voip_ext'][$cnt][6] = $val3;
										break;
								}
							}
							
							$cnt++;
						}
					} else {
						switch(strtolower($key1)) {
							case "voipid":
								$GLOBALS['ss_voipid'] = $val1;
								break;
							case "switch":
								$GLOBALS['ss_voip_opn'] = $val1;
								break;
							case "port":
								$GLOBALS['ss_voip_port'] = $val1;
								break;
							case "ipadd":
								$GLOBALS['ss_voip_interface'] = $val1;
								break;
							case "paymode":
								$GLOBALS['ss_voip_paymode'] = $val1;
								break;
							case "key":
								$GLOBALS['ss_voip_actkey'] = $val1;
								break;
							case "deactivate":
								$GLOBALS['ss_voip_deactvobal'] = $val1;
								break;
							case "uid":
								$GLOBALS['ss_voip_uid'] = $val1;
								break;
							case "did":
								$GLOBALS['ss_voip_did'] = $val1;
								break;
						}
					}
				}
			}
		}
		
		debugEcho( "ss_voipid: " . $GLOBALS['ss_voipid'] );
		debugEcho( "ss_voip_opn: " . $GLOBALS['ss_voip_opn'] );
		debugEcho( "ss_voip_port: " . $GLOBALS['ss_voip_port'] );
		debugEcho( "ss_voip_interface: " . $GLOBALS['ss_voip_interface'] );
		debugEcho( "ss_voip_paymode: " . $GLOBALS['ss_voip_paymode'] );
		debugEcho( "ss_voip_numexts: " . $GLOBALS['ss_voip_numexts'] );
		debugEcho( "ss_voip_actkey: " . $GLOBALS['ss_voip_actkey'] );
		debugEcho( "ss_voip_deactvobal: " . $GLOBALS['ss_voip_deactvobal'] );
		debugEcho( "ss_voip_uid: " . $GLOBALS['ss_voip_uid'] );
		debugEcho( "ss_voip_did: " . $GLOBALS['ss_voip_did'] );
		debugEcho( "ss_voip_ext: " );
		debugPrintR( $GLOBALS['ss_voip_ext'] );
		
		return $ret;
	}
	
	$GLOBALS['ll_voip_uid'] = "";
	$GLOBALS['ll_voip_did'] = "";
	function getVOIPVOBALConfigLocal() {
		$durl = $GLOBALS['RPVOIP'] . '?getvobal';
		debugEcho($durl);
		
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'GET',
				'content' => http_build_query($jsonEncodedContent)
			)
		));
		
		$response = file_get_contents($durl, false, $context);
		if ($response === FALSE){
		} else {
			$response = str_replace("</pre>", "", $response);
			$response = str_replace("</pre>", "", $response);
			$response = str_replace("<pre>", "", $response);
			$response = str_replace("<pre>", "", $response);
			$responseArr = explode("\n", $response);
			
			for ($i=0; $i<count($responseArr); $i++) {
				if (strrpos($responseArr[$i], "uid") === false) {} else {
					$GLOBALS['ll_voip_uid'] = trim( str_replace( "uid=", "", str_replace( "'", "", str_replace( "'", "", $responseArr[$i] ) ) ) );
				}
				
				if (strrpos($responseArr[$i], "did") === false) {} else {
					$GLOBALS['ll_voip_did'] = trim( str_replace( "did=", "", str_replace( "'", "", str_replace( "'", "", $responseArr[$i] ) ) ) );
				}
			}
			
			getVOIPEXTConfigLocal();
		}
	}
	
	function getVOIPEXTConfigLocal() {
		$ll_voip_ext = array(array()); $ll_voip_numexts = 0;
		
		$durl = $GLOBALS['RPVOIP'] . '?getextension';
		debugEcho($durl);
		
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'GET',
				'content' => http_build_query($jsonEncodedContent)
			)
		));
		
		$response = file_get_contents($durl, false, $context);
		if ($response === FALSE){
		} else {
			$response = str_replace("</pre>", "", $response);
			$response = str_replace("</pre>", "", $response);
			$response = str_replace("<pre>", "", $response);
			$response = str_replace("<pre>", "", $response);
			$responseArr = explode("\n", $response);
			debugPrintR($responseArr);
			
			$cnt = 0;
			$indx = "0"; $subs = array('0','0','prepaid','','','','');
			for ($i=0; $i<count($responseArr); $i++) {
				if (strlen( trim( $responseArr[$i] ) ) > 0) {
					$cnt++;
					
					$tmp = str_replace("[", "", $responseArr[$i]);
					$tmp = str_replace("]=", "<DEL>", $tmp);
					$tmp = str_replace("].", "<DEL>", $tmp);
					$tmpArr = explode("<DEL>", $tmp);
					
					if ($indx != $tmp[0]) {
						$ll_voip_ext[$ll_voip_numexts] = $subs;
						$ll_voip_numexts++;
						
						$subs = array('0','0','prepaid','','','','');
						
						$indx = $tmp[0];
					}
					
					$tmpArr1 = explode("=", $tmpArr[1]);
					switch(strtolower($tmpArr1[0])) {
						case "ring":
							$subs[0] = str_replace("'", "", $tmpArr1[1]);
							break;
						case "sms":
							$subs[1] = str_replace("'", "", $tmpArr1[1]);
							break;
						case "paymode":
							$subs[2] = str_replace("'", "", $tmpArr1[1]);
							break;
						case "id": //extension
							$subs[3] = str_replace("'", "", $tmpArr1[1]);
							break;
						case "password":
							$subs[4] = str_replace("'", "", $tmpArr1[1]);
							break;
						case "callerid":
							$subs[5] = str_replace("'", "", $tmpArr1[1]);
							break;
						case "description":
							$subs[6] = str_replace("'", "", $tmpArr1[1]);
							break;
					}
				}
			}
			if ($cnt > 0) {
				$ll_voip_ext[$ll_voip_numexts] = $subs;
				$ll_voip_numexts++;
			}
			debugEcho( "ll_voip_numexts: " . $ll_voip_numexts );
			debugPrintR( $ll_voip_ext );
		}
		
		if (count($ll_voip_ext) > 0) {
			delVOIPEXTConfigLocal($ll_voip_ext);
		} else {
			saveVOIPPBXConfigLocal();
		}
	}
	
	function delVOIPEXTConfigLocal($arrVOIPExt) {
		for ($i=0; $i<count($arrVOIPExt); $i++) {
			$durl = $GLOBALS['RPVOIP'] . '?delextension&id=' . $arrVOIPExt[$i][3];
			debugEcho($durl);
			
			$context = stream_context_create(array(
				'http' => array(
					'header'  => "Content-Type: application/x-www-form-urlencoded",
					'method'  => 'GET',
					'content' => http_build_query($jsonEncodedContent)
				)
			));
			
			$response = file_get_contents($durl, false, $context);
			if ($response === FALSE){
			} else {
				debugEcho( $response );
			}
		}
		
		saveVOIPPBXConfigLocal();
	}
	
	function saveVOIPPBXConfigLocal() {
		$durl = $GLOBALS['RPVOIP'] . '?setpbx&enabled=' . $GLOBALS['ss_voip_opn'] . '&listen_interfaces=' . $GLOBALS['ss_voip_interface'] . '&listen_port=' . ((strlen($GLOBALS['ss_voip_port']) == 0)?"5060":$GLOBALS['ss_voip_port']);
		debugEcho($durl);
		
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'GET',
				'content' => http_build_query($jsonEncodedContent)
			)
		));
		
		$response = file_get_contents($durl, false, $context);
		if ($response === FALSE){
		} else {
			saveVOIPFXSConfigLocal();
		}
	}
	
	function saveVOIPFXSConfigLocal() {
		$durl = $GLOBALS['RPVOIP'] . '?setfxs&paymode=' . $GLOBALS['ss_voip_paymode'];
		debugEcho($durl);
		
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'GET',
				'content' => http_build_query($jsonEncodedContent)
			)
		));
		
		$response = file_get_contents($durl, false, $context);
		if ($response === FALSE){
		} else {
			saveVOIPVOBALConfigLocal();
		}
	}
	
	function saveVOIPVOBALConfigLocal() {
		$durl = $GLOBALS['RPVOIP'] . '?setvobal&enabled=' . (($GLOBALS['ss_voip_deactvobal']=="0")?"1":"0") . '&key=' . $GLOBALS['ss_voip_actkey'];
		debugEcho($durl);
		
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'GET',
				'content' => http_build_query($jsonEncodedContent)
			)
		));
		
		$response = file_get_contents($durl, false, $context);
		if ($response === FALSE){
		} else {
			//saveVOIPConfig();
			saveVOIPEXTConfigLocal();
		}
	}
	
	function saveVOIPConfig() {
		$durl = $GLOBALS['SERVERURL'] . 'redportapi/lib/voipsettings.php';
		debugEcho($durl);
		
		$postData = array(
			'voipmacid' => $GLOBALS['macid'],
			'voipvessid' => '',
			'voipswitch' => $GLOBALS['ss_voip_opn'],
			'voipport' => ((strlen($GLOBALS['ss_voip_port']) == 0)?"5060":$GLOBALS['ss_voip_port']),
			'voipIP' => $GLOBALS['ss_voip_interface'],
			'voippay' => $GLOBALS['ss_voip_paymode'],
			'activkey' => $GLOBALS['ss_voip_actkey'],
			'deactivunit' => $GLOBALS['ss_voip_deactvobal'],
			'voipUID' => $GLOBALS['ll_voip_uid'],
			'voipDID' => $GLOBALS['ll_voip_did'],
			'partner' => '',
			'fleetid' => '',
			'id' => $GLOBALS['ss_voipid'], //'0',
			'proc' => '2',
			'source' => '0'
		);
		debugPrintR( $postData );
		
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'POST',
				'content' => http_build_query($postData)
			)
		));
		
		$response = file_get_contents($durl, false, $context);
		if ($response === FALSE){
		} else {
		}
		
		//saveVOIPEXTConfigLocal();
	}
	
	function saveVOIPEXTConfigLocal() {
		for ($i=0; $i<count($GLOBALS['ss_voip_ext']); $i++) {
		
			$durl = $GLOBALS['RPVOIP'] . '?addextension&ring=' . $GLOBALS['ss_voip_ext'][$i][0] . '&sms=' . $GLOBALS['ss_voip_ext'][$i][1] . '&paymode=' 
				. $GLOBALS['ss_voip_ext'][$i][2] . '&id=' . urlencode($GLOBALS['ss_voip_ext'][$i][3]) . '&password=' . urlencode($GLOBALS['ss_voip_ext'][$i][4]) . '&callerid=' 
				. urlencode($GLOBALS['ss_voip_ext'][$i][5]) . '&description=' . urlencode($GLOBALS['ss_voip_ext'][$i][6]);
			debugEcho($durl);
			
			$context = stream_context_create(array(
				'http' => array(
					'header'  => "Content-Type: application/x-www-form-urlencoded",
					'method'  => 'GET',
					'content' => http_build_query($jsonEncodedContent)
				)
			));
			
			$response = file_get_contents($durl, false, $context);
			if ($response === FALSE){
			} else {
			}
		
		}
		
		saveVOIPConfig();
	}
	//VOIP SETTINGS
	
	//EMAIL SETTINGS
	$GLOBALS['ss_email_id'] = "";
	$GLOBALS['ss_email_opn'] = "0";
	$GLOBALS['ss_email_mainuser'] = "";
	$GLOBALS['ss_email_mainpass'] = "";
	$GLOBALS['ss_email_domain'] = "";
	$GLOBALS['ss_email_interval'] = ""; //60
	$GLOBALS['ss_email_ext_prime'] = array(array());
	//$GLOBALS['ss_email_numexts_prime'] = 0;
	$GLOBALS['ss_email_ext'] = array(array());
	//$GLOBALS['ss_email_numexts'] = 0;
	
	function getEmailSettings() {
		$GLOBALS['ss_email_ext_prime'] = array(array());
		$ss_email_numexts_prime = 0;
		$GLOBALS['ss_email_ext'] = array(array());
		$ss_email_numexts = 0;
		
		$ret = true;
		$postData = array('macid' => $GLOBALS['macid'], 'vesselid' => "", 'source' => "0");
		debugPrintR($postData);
		$durl = $GLOBALS['SERVERURL'] . 'redportapi/rest/requestemailsettings';
		debugEcho( "EMAIL: " . $durl );	
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'POST',
				'content' => http_build_query($postData)
			)
		));
		$response = file_get_contents($durl, false, $context);
		
		if ($response === FALSE){
			$ret = false;
		} else {
			$res = json_decode($response, true);
			debugPrintR($res);
			
			foreach($res as $key=>$val){ 
				foreach($val as $key1=>$val1){ 
					if ($key1 == "emailprimary") {
						foreach($val1 as $key2=>$val2){
							foreach($val2 as $key3=>$val3){
								switch(strtolower($key3)) {
									case "username":
										$GLOBALS['ss_email_ext_prime'][$ss_email_numexts_prime][0] = $val3;
										break;
									case "password":
										$GLOBALS['ss_email_ext_prime'][$ss_email_numexts_prime][1] = $val3;
										break;
									case "emaildesc":
										$GLOBALS['ss_email_ext_prime'][$ss_email_numexts_prime][2] = $val3;
										break;
								}
							}
							
							$ss_email_numexts_prime++;
						}
					} else if ($key1 == "emailsub") {
						foreach($val1 as $key2=>$val2){
							foreach($val2 as $key3=>$val3){
								switch(strtolower($key3)) {
									case "xgatesubaccount":
										$GLOBALS['ss_email_ext'][$ss_email_numexts][0] = $val3;
										break;
									case "username":
										$GLOBALS['ss_email_ext'][$ss_email_numexts][1] = $val3;
										break;
									case "password":
										$GLOBALS['ss_email_ext'][$ss_email_numexts][2] = $val3;
										break;
									case "subacctdesc":
										$GLOBALS['ss_email_ext'][$ss_email_numexts][3] = $val3;
										break;
								}
							}
							
							$ss_email_numexts++;
						}
					} else {
						switch(strtolower($key1)) {
							case "id":
								$GLOBALS['ss_email_id'] = $val1;
								break;
							case "switch":
								$GLOBALS['ss_email_opn'] = $val1;
								break;
							case "username":
								$GLOBALS['ss_email_mainuser'] = $val1;
								break;
							case "password":
								$GLOBALS['ss_email_mainpass'] = $val1;
								break;
							case "satdomain":
								$GLOBALS['ss_email_domain'] = $val1;
								break;
							case "tracking":
								$GLOBALS['ss_email_interval'] = $val1;
								break;
						}
					}
				}
			}
		}
		
		debugEcho( "ss_email_id: " . $GLOBALS['ss_email_id'] );
		debugEcho( "ss_email_opn: " . $GLOBALS['ss_email_opn'] );
		debugEcho( "ss_email_mainuser: " . $GLOBALS['ss_email_mainuser'] );
		debugEcho( "ss_email_mainpass: " . $GLOBALS['ss_email_mainpass'] );
		debugEcho( "ss_email_domain: " . $GLOBALS['ss_email_domain'] );
		debugEcho( "ss_email_interval: " . $GLOBALS['ss_email_interval'] );
		debugEcho( "ss_email_ext_prime: " );
		debugPrintR( $GLOBALS['ss_email_ext_prime'] );
		debugEcho( "ss_email_ext: " );
		debugPrintR( $GLOBALS['ss_email_ext'] );
		
		return $ret;
	}
	
	$GLOBALS['ll_email_ids'] = array(array()); $GLOBALS['ll_email_ids_cnt'] = 0;
	function getEmailConfigPrimeLocal() {
		$GLOBALS['ll_email_ids'] = array(array());
		$GLOBALS['ll_email_ids_cnt'] = 0;
		
		$durl = $GLOBALS['RPEMAIL'] . '?showpa';
		debugEcho($durl);
		
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'GET',
				'content' => http_build_query($jsonEncodedContent)
			)
		));
		
		$response = file_get_contents($durl, false, $context);
		if ($response === FALSE){
		} else {
			$response = str_replace("</pre>", "", $response);
			$response = str_replace("</pre>", "", $response);
			$response = str_replace("<pre>", "", $response);
			$response = str_replace("<pre>", "", $response);
			$responseArr = explode("\n", $response);
			debugPrintR($responseArr);
			
			$cnt = 0;
			$indx = "0";
			for ($i=0; $i<count($responseArr); $i++) {
				if (strlen( trim( $responseArr[$i] ) ) > 0) {
					$cnt++;
					
					$tmp = str_replace("[", "", $responseArr[$i]);
					$tmp = str_replace("]=", "<DEL>", $tmp);
					$tmp = str_replace("].", "<DEL>", $tmp);
					$tmpArr = explode("<DEL>", $tmp);
					
					if ($indx != $tmp[0]) {
						$GLOBALS['ll_email_ids_cnt']++;
						
						$indx = $tmp[0];
					}
					
					$tmpArr1 = explode("=", $tmpArr[1]);
					switch(strtolower($tmpArr1[0])) {
						case "username":
							$GLOBALS['ll_email_ids'][$GLOBALS['ll_email_ids_cnt']][0] = str_replace("'", "", $tmpArr1[1]);
							$GLOBALS['ll_email_ids'][$GLOBALS['ll_email_ids_cnt']][1] = "PRIME";
							break;
					}
				}
			}
			if ($cnt > 0) {
				$GLOBALS['ll_email_ids_cnt']++;
			}
		}
		
		getEmailConfigSubLocal();
	}
	
	function getEmailConfigSubLocal() {
		$durl = $GLOBALS['RPEMAIL'] . '?showsa';
		debugEcho($durl);
		
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'GET',
				'content' => http_build_query($jsonEncodedContent)
			)
		));
		
		$response = file_get_contents($durl, false, $context);
		if ($response === FALSE){
		} else {
			$response = str_replace("</pre>", "", $response);
			$response = str_replace("</pre>", "", $response);
			$response = str_replace("<pre>", "", $response);
			$response = str_replace("<pre>", "", $response);
			$responseArr = explode("\n", $response);
			debugPrintR($responseArr);
			
			$cnt = 0;
			$indx = "0";
			for ($i=0; $i<count($responseArr); $i++) {
				if (strlen( trim( $responseArr[$i] ) ) > 0) {
					$cnt++;
					
					$tmp = str_replace("[", "", $responseArr[$i]);
					$tmp = str_replace("]=", "<DEL>", $tmp);
					$tmp = str_replace("].", "<DEL>", $tmp);
					$tmpArr = explode("<DEL>", $tmp);
					
					if ($indx != $tmp[0]) {
						$GLOBALS['ll_email_ids_cnt']++;
						
						$indx = $tmp[0];
					}
					
					$tmpArr1 = explode("=", $tmpArr[1]);
					switch(strtolower($tmpArr1[0])) {
						case "username":
							$GLOBALS['ll_email_ids'][$GLOBALS['ll_email_ids_cnt']][0] = str_replace("'", "", $tmpArr1[1]);
							$GLOBALS['ll_email_ids'][$GLOBALS['ll_email_ids_cnt']][1] = "SUB";
							break;
					}
				}
			}
			if ($cnt > 0) {
				$GLOBALS['ll_email_ids_cnt']++;
			}
			
			debugEcho( "ll_email_ids_cnt: " . $GLOBALS['ll_email_ids_cnt'] );
			debugPrintR( $GLOBALS['ll_email_ids'] );
		}
		
		if (count($GLOBALS['ll_email_ids']) > 0) {
			deleteEmailSubConfigLocal();
		} else {
			saveEmailConfigLocal();
		}
	}
	
	function deleteEmailSubConfigLocal() {
		for ($i=0; $i<count($GLOBALS['ll_email_ids']); $i++) {
			
			$durl = $GLOBALS['RPEMAIL'] . '?delsa&username=' . urlencode($GLOBALS['ll_email_ids'][$i][0]);
			if ($GLOBALS['ll_email_ids'][$i][1] == "PRIME") {
				$durl = $GLOBALS['RPEMAIL'] . '?delpa&username=' . urlencode($GLOBALS['ll_email_ids'][$i][0]);
			}
			debugEcho($durl);
			
			$context = stream_context_create(array(
				'http' => array(
					'header'  => "Content-Type: application/x-www-form-urlencoded",
					'method'  => 'GET',
					'content' => http_build_query($jsonEncodedContent)
				)
			));
			
			$response = file_get_contents($durl, false, $context);
			if ($response === FALSE){
			} else {
				debugEcho($response);
			}
		
		}
		
		saveEmailConfigLocal();
	}
	
	function saveEmailConfigLocal() {
		$durl = $GLOBALS['RPEMAIL'];
		debugEcho($durl);
		
		$postData = array(
			'setgen' => 'setgen',
			'enabled' => $GLOBALS['ss_email_opn'],
			'username' => $GLOBALS['ss_email_mainuser'],
			'password' => $GLOBALS['ss_email_mainpass'],
			'interval' => ((strlen($GLOBALS['ss_email_interval']) == 0)?"60":$GLOBALS['ss_email_interval']),
			'sat_domain' => ((strlen($GLOBALS['ss_email_domain']) == 0)?"redportglobal.com":$GLOBALS['ss_email_domain'])
		);
		debugPrintR($postData);
		
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'POST',
				'content' => http_build_query($postData)
			)
		));
		
		$response = file_get_contents($durl, false, $context);
		if ($response === FALSE){
		} else {
			debugEcho($response);
		}
		
		saveEmailPrimeConfigLocal();
	}
	
	function saveEmailPrimeConfigLocal() {
		for ($i=0; $i<count($GLOBALS['ss_email_ext_prime']); $i++) {
			
			$durl = $GLOBALS['RPEMAIL'] . '?addpa&username=' . urlencode($GLOBALS['ss_email_ext_prime'][$i][0]) . '&password=' . urlencode($GLOBALS['ss_email_ext_prime'][$i][1])
				 . '&description=' . urlencode($GLOBALS['ss_email_ext_prime'][$i][2]);
			debugEcho($durl);
			
			$context = stream_context_create(array(
				'http' => array(
					'header'  => "Content-Type: application/x-www-form-urlencoded",
					'method'  => 'GET',
					'content' => http_build_query($jsonEncodedContent)
				)
			));
			
			$response = file_get_contents($durl, false, $context);
			if ($response === FALSE){
			} else {
				debugEcho($response);
			}
		
		}
		
		saveEmailSubConfigLocal();
	}
	
	function saveEmailSubConfigLocal() {
		for ($i=0; $i<count($GLOBALS['ss_email_ext']); $i++) {
			
			$durl = $GLOBALS['RPEMAIL'] . '?addsa&username=' . urlencode($GLOBALS['ss_email_ext'][$i][1]) . '&password=' . urlencode($GLOBALS['ss_email_ext'][$i][2])
				 . '&description=' . urlencode($GLOBALS['ss_email_ext'][$i][3]) . '&primary=' . urlencode($GLOBALS['ss_email_ext'][$i][0]);
			debugEcho($durl);
			
			$context = stream_context_create(array(
				'http' => array(
					'header'  => "Content-Type: application/x-www-form-urlencoded",
					'method'  => 'GET',
					'content' => http_build_query($jsonEncodedContent)
				)
			));
			
			$response = file_get_contents($durl, false, $context);
			if ($response === FALSE){
			} else {
				debugEcho($response);
			}
		
		}
	}
	
	/**
	NOTES TO DO
	GET EMAIL PRIMARY ACCOUNTS THEN DELETE ALL!!!
	GET EMAIL SUB ACCOUNTS THEN DELETE ALL!!!
	**/
	//EMAIL SETTINGS
	
	if ($GLOBALS['ss_update_remote'] == "1") {
		if (getRemoteSettings()) {
			saveRemoteConfigLocal();
		}
	}
	if ($GLOBALS['ss_update_gps'] == "1") {
		if (getGPSSettings()) {
			saveGPSConfigLocal();
		}
	}
	if ($GLOBALS['ss_update_voip'] == "1") {
		if (getVOIPSettings()) {
			getVOIPVOBALConfigLocal();
		}
	}
	if ($GLOBALS['ss_update_email'] == "1") {
		if (getEmailSettings()) {
			getEmailConfigPrimeLocal();
		}
	}
	
	debugEcho( "" );
	debugEcho( "" );
	debugEcho( "ALL DONE!" );
	debugEcho( "===================================" );
	debugEcho( "" );
	debugEcho( "" );
	debugEcho( "" );
?>