#!/usr/bin/php-cgi
<?php
  include("topinsert.php");
?>
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
    <title><?php echo $dTitle; ?></title>

    <link href="<?php echo $GLOBALS['vendorsPath']?>vendors/bootstrap/css/bootstrap.min.css" rel="stylesheet">
    <link href="<?php echo $GLOBALS['vendorsPath']?>vendors/fontawesome/css/font-awesome.min.css" rel="stylesheet">
    <?php include $GLOBALS['assetsPath'].'css/style.php';?>
    <script src="<?php echo $GLOBALS['vendorsPath']?>vendors/js/modernzr.custom.js"></script>
    <?php include $GLOBALS['assetsPath'].'css/menu.php';?>
    
    <?php include "../m/funcjs.php"; ?>
  </head>
  <body>
    <!-- start counters -->
    <div class="container no-pad-all">
    <?php include 'counter.php';?>    
    </div>
    <!-- end counters -->
    
    <div class="container no-pad-all container-main">
        <!-- The Header Part -->
        <div class="row-fluid hidden-xs hidden-sm">
          <div class="header-main col-md-12 col-md-12"></div>
        </div><!--End The Header Part -->

        <div class="row-fluid">
              <div class="container-main col-md-12 col-md-12">
                <!--Start THe Sidebar -->
                <?php include 'sidebar.php';?>
                <!--End THe Sidebar -->

                <!-- THe Content -->
                <div id="main-content" class=" col-md-9 col-lg-9 col-sm-9 content col-xs-9">
                  <!-- right side -->
                  <div class="main-content">
                    <!-- content here starts -->


                      <div class="panel panel-dark" style="min-height: 530px;">
                        <div class="panel-heading">
                          <h3 class="panel-title panel-title-large"><img src="<?php echo $GLOBALS['linkPath']?>/images/vesselmedia-gold.png" class="ptl"> Vessel Media</h3>
                        </div>
                        <div class="panel-body panel-main-content"
                        	style="padding: 5px 10px 15px 10px !important;">
                          
                              <div class="announcements-block"
                                  style="
                                  	overflow: auto !important;
                                    min-height: 530px;
                                    padding: 0px 0px 0px 0px !important;
                                    background:#E3E3E3;
                                    border: 0px solid #bcbcbc;
                                    -webkit-border-radius: 0px;
                                    -moz-border-radius: 0px;
                                    border-radius: 0px;
                                    height: 530px;
                                  "
                                  >

									<div class="news-item-listing" align="center">
                                        <i class="fa fa-spinner fa-spin"></i> Retrieving Vessel Media
                                    </div>
 
							  </div>
                              <div class="clearfix"></div>
                        </div>
                      </div>
                      <!-- footer -->
                      <div class="footer"><img class="footer-image" src="<?php echo $GLOBALS['linkPath']?>images/smsgloballogo_.png"></div>
                      <!-- footer -->
                      <!-- content here Ends -->
                      <div class="clearfix"></div>
                  </div><!--End #main-content .main-content -->
                </div><!--End #main-content -->
              </div>
            </div>
        </div>
    </div>

    <!-- MODALS STARTS HERE -->
    <?php include 'controlpanel.php';?>
    <!-- MODALS ENDS HERE -->

	<?php include 'reload.php'; ?>
    <?php include '../m/inetrelated.php'; ?>

    <?php $mobileSiteShow = true?>
    <script src="<?php echo $GLOBALS['vendorsPath']?>vendors/jquery/jquery.js"></script>
	<script src="<?php echo $GLOBALS['vendorsPath']?>vendors/jquery/jquery-ui.min.js"></script>
    <script src="<?php echo $GLOBALS['vendorsPath']?>vendors/bootstrap/js/bootstrap.min.js"></script>  
    <script src="<?php echo $GLOBALS['vendorsPath']?>vendors/js/jquery.bpopup.min.js"></script>
    <script type="text/javascript" src="<?php echo $GLOBALS['mobilePath']; ?>vendors/cropbox.js"></script>
    <script src="<?php echo $GLOBALS['vendorsPath']?>js/main.js"></script>
    <script type="text/javascript" src="<?php echo $GLOBALS['mobilePath']; ?>js/jquery.base64.js"></script>
    
    <?php if(isset($mobileSiteShow) &&  $mobileSiteShow === true):?>
        <?php echo detectUserAgent(' style="width:100%;padding:0 0 10px; 0" align="center"'); ?>
    <?php else:?>
        <div class="mobile-browser-tablet-detect__footer">
            <?php echo detectUserAgent(' style="width:100%;padding:0 0 10px; 0" align="center"'); ?>
        </div>
    <?php endif;?>

	<?php include "loading.php"; ?>
    <iframe id="downloadframe" style='display:none;'></iframe>
    <?php include "dfoot.php"; ?>
  </body>
</html>
<script>
//var dirlist = 'http://<?php //echo (($_SERVER['SERVER_ADDR'] == "::1")?"localhost":$_SERVER['SERVER_ADDR']); ?>/cgi-bin/dirlistgui.php'; //Add this to a variable
var dirlist = '<?php echo (($linksys)?"http://" . $_SERVER['SERVER_ADDR']."/cgi-bin/dirlistgui.php":"http://localhost/smscrewmail/mailparser/production/serverfiles/management/dirlistgui.php"); ?>'; //Add this to a variable
//var servdhost = 'http://192.168.32.1/cgi-bin/serv.php'; //Add this to a variable
var currpath = "";
var selectdf = "";

function myTrim(x) {
	return x.replace(/^\s+|\s+$/gm,'');
}

function fetchDirJS(path, act, fname) {
	currpath = path;
	
	var requestdirlist;
	var noerror = true;
	var dhost = dirlist;
	var mediaCnt = 0;
	
	requestdirlist = $.ajax({
		url: dhost,
		type: "post",
		data: { path: path, act: act, fname: fname },
		//dataType:"json",
		timeout: 30000
	});
	
	requestdirlist.done(function (response, textStatus, jqXHR){
		if (noerror) {
			try {
			
				response = response.replace("#!/usr/bin/php-cgi", "");
				response = myTrim(response);
				var ret = response.split("[FILESEP]");
				try {
					$('div.announcements-block').empty();
					for (var i=0;i<ret.length;i++) {
						ret[i] = ret[i].replace("[FILESEP]", "");
						if (ret[i] == "No files found.") {
						} else {
							if (ret[i].length > 0) {
								//Process filename here, call showopts with ret[i] as parameter for download option
								disp = '<div class="news-item-listing" style="margin-bottom: 0px !important;"><a href="javascript:;" onClick="showopts(\'' + ret[i] + '\')">';
								disp += '<h1 class="news-listings__title" style="padding:5px !important; margin-top:10px !important; font-size:15px">' + ret[i] + '</h1>';
								disp += '</a></div>';
								
								$('div.announcements-block').append(
									disp
								);
								
								mediaCnt++;
							}
						}
					}
				} catch (e) {}
				
				if (mediaCnt == 0) {
					$('div.announcements-block').empty();
					disp = '<div class="news-item-listing" align="center">';
					disp += 'No media files available.';
					disp += '</div>';
					$('div.announcements-block').append(
						disp
					);
				}
			
			} catch (e) {}
		}
	});

	requestdirlist.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
		/*if (textStatus=="timeout") {
			alert('The request timed out. Please try again.');
		} else {
			alert('An error has occurred. Please try again.');
		}*/
		
		$('div.announcements-block').empty();
		disp = '<div class="news-item-listing" align="center">';
		disp += 'No media files available.';
		disp += '</div>';
		$('div.announcements-block').append(
			disp
		);
	});

	requestdirlist.always(function () {
		requestdirlist = null;
	});
}

//Called this function (filename as parameter) when the user clicks on a media item.
function showopts(fn) {
	selectdf = fn;
	
	/*if (confirm("Are you sure you want to download " + selectdf + "?")) {
		downloadopts();
	}*/
	
	sweetAlert({
			title: "Vessel Media",
			text: "Are you sure you want to download " + selectdf + "?",
			showCancelButton: true,
			confirmButtonText: "Yes",
			cancelButtonText: "No",
			closeOnConfirm: true,
			closeOnCancel: true 
		},
		function(isConfirm){
			if (isConfirm) {
				downloadopts();
			}
		}
	);
}

function downloadopts() {
	var dhost = 'http://<?php echo (($_SERVER['SERVER_ADDR'] == "::1")?"localhost":$_SERVER['SERVER_ADDR']); ?>/cgi-bin/serv.php';
	document.getElementById('downloadframe').src = dhost + "?act=2&path=" + encodeURIComponent(currpath.replace(/&amp;/g, "&")) + "&fname=" + encodeURIComponent(selectdf.replace(/&amp;/g, "&"));
}

fetchDirJS(currpath, "1", ""); //Call this to fetch media file list

$(document).ready(function(){
	fetchDirJS(currpath, "1", "");
});
</script>
<?php include "../m/foot.php"; ?>